class PcMode
{
  static get mode()
  {
    return PcConfig.scenario.mode;
  }

  static get screen()
  {
    let mode = PcConfig.scenario.mode;

    //////////////////////////////////////////////////////////////////////////
    // BOOTH MODE

    if (mode=="photobooth" || mode=="videobooth")
    {
      return {
        format:{
          titleY:0.03,
          sliderY:0.25,
          sliderH:0.5,
          buttonsY:0.89,
          buttonsJustify:"space-evenly",
          slidersRatio:0.825,
        },
        start:{
          buttonPreviousY:0.853,
          buttonPreviousX:0.02,
          buttonPreviousJustify:"flex-start",
        },
        templateAndFilter:{
          titleY:0.03,
          sliderY:0.15, // previously was 0.18 but we need some space to add the removebg optional on/off button
          sliderH:0.75,
          buttonsY:0.89,
          slidersRatio:1.2,
          filtersRatio:1,
        },
        infos:{
          formW:0.6,
          formKeyboardH:0.4,
          formKeyboardY:0.67,
          formPositionWithoutKeyboard:300,
          formPositionWithKeyboard:50,
          formPositionWithKeyboardId:0,
        },
      }
    }

    //////////////////////////////////////////////////////////////////////////
    // CYCLOMATON MODE

    if (mode=="cyclomaton")
    {
      return {
        format:{
          titleY:0.03,
          sliderY:0.25,
          sliderH:0.5,
          buttonsY:0.89,
          buttonsJustify:"space-evenly",
          slidersRatio:0.825,
        },
        start:{
          buttonPreviousY:0.853,
          buttonPreviousX:0.02,
          buttonPreviousJustify:"flex-start",
        },
        templateAndFilter:{
          titleY:0.03,
          sliderY:0.18,
          sliderH:0.75,
          buttonsY:0.89,
          slidersRatio:0.8,
          filtersRatio:1,
        },
        infos:{
          formW:0.6,
          formKeyboardH:0.4,
          formKeyboardY:0.65,
          formPositionWithoutKeyboard:300,
          formPositionWithKeyboard:100,
          formPositionWithKeyboardId:0,
        },
      }
    }


    //////////////////////////////////////////////////////////////////////////
    // KIOSK MODE

    if (mode=="photokiosk" || mode=="videokiosk")
    {
      return {
        format:{
          titleY:0.02,
          sliderY:0.15,
          sliderH:0.3,
          buttonsY:0.5,
          buttonsJustify:"space-around",
          slidersRatio:1.4,
        },
        start:{
          buttonPreviousY:0.853,
          buttonPreviousX:0.3,
          buttonPreviousJustify:"center",
        },
        templateAndFilter:{
          titleY:0.02,
          sliderY:0.15,
          sliderH:0.45,
          buttonsY:0.6,
          slidersRatio:1.4,
          filtersRatio:1.5,
        },
        infos:{
          formW:0.8,
          formKeyboardH:0.3,
          formKeyboardY:0.58,
          formPositionWithoutKeyboard:350,
          formPositionWithKeyboard:222,
          formPositionWithKeyboardId:0,
        },
      }
    }

  }
}
