import enum

class ValinaIncident(enum.IntEnum):

    VALINA_INCIDENT_POSITIVE_MESSAGE = 0,
    VALINA_INCIDENT_DEVICE_CANCELLATION = 0x2630, #bad type of card (keyfob)
    VALINA_INCIDENT_NO_PURSE_AND_TIMEOUT = 0x4100, #card not presented in time 
    VALINA_INCIDENT_PURSE_STATE_ERROR = 0x4008,
    VALINA_INCIDENT_PURSE_EXPIRED = 0x4007,
    VALINA_INCIDENT_INSUFFICIENT_PURSE_BALANCE = 0x4011,
    VALINA_INCIDENT_PURSE_RED_LIST = 0x4004,
    VALINA_INCIDENT_PURSE_LOCKED_CREDIT = 0x4005,
    VALINA_INCIDENT_PURSE_LOCKED_DEBIT = 0x4006,
    VALINA_INCIDENT_TECHNICAL_PROBLEM = 0x1811,
    VALINA_INCIDENT_UNEXPECTED_MESSAGE = 0x1802


class ValinaExceptionCode(enum.IntEnum):

    VALINA_OK =                                  0
    VALINA_ERR_NOT_INITIALISED =                 -1
    VALINA_ERR_TERMINAL_DISCONNECTED =            -2
    VALINA_ERR_TERMINAL_BUSY =                   -3
    VALINA_ERR_BAD_REPLY =                       -4
    VALINA_ERR_CTEP_ENCODE =                      -5
    VALINA_ERR_EMIT =                             -6
    VALINA_ERR_SOCKET_LISTEN =                   -7
    VALINA_ERR_CTEP_BUILD_ERROR =                -8
    VALINA_ERR_TIMEOUT =                         -9
    VALINA_ERR_OUT_OF_MEM =                       -10
    VALINA_ERR_BAD_PARAM =                       -11
    VALINA_ERR_UNKNOWN_TICKET_TYPE =             -12
    VALINA_ERR_TICKET_NOT_AVAILABLE =           -13
    VALINA_ERR_UNKNOWN_APPLICATION_ID =         -14
    VALINA_ERR_BUFFER_TOO_SHORT =                -15
    VALINA_ERR_FUNCTION_ALREADY_RUNNING =        -16
    VALINA_ERR_BAD_POSWARE_VERSION =             -17

    #  KISS protocol error codes 
    VALINA_ERR_COMM_EMIT_NO_ACK =               -21         	#No ack to sent message
    VALINA_ERR_COMM_EMIT_BAD_SEQ =			    -24				#Bad sequence number
    VALINA_ERR_COMM_EMIT_WRITE =                -25             #Failed to write data

    VALINA_ERR_COMM_RECV_NO_STX =               -31    			#No STX received
    VALINA_ERR_COMM_RECV_NO_SEQ =              -32             #No sequence number received
    VALINA_ERR_COMM_RECV_OTHER =                -33             #Receive error - other
    VALINA_ERR_COMM_RECV_TIMEOUT =               -34             #Receive timeout
    VALINA_ERR_COMM_RECV_NO_CRC =               -35    			#No CRC received
    VALINA_ERR_COMM_RECV_BAD_CRC =              -36           	#Bad crc received
    VALINA_ERR_COMM_RECV_MAX_RETRY =            -37             #Too much tries
    VALINA_ERR_COMM_BUFFER_FULL =              -38             #Buffer full

    VALINA_ERR_OTHER =                           -1000

class MyValinaException(Exception):
	 # Constructor or Initializer 
	def __init__(self, value): 
		self.value = value 

	def get_value(self):
		return self.value
		
	def __str__(self): 
		return(repr(self.value)) 

class MagicReaderStatus(enum.IntEnum):
    READER_STATUS_OK = 48

