<?php
include_once 'config.php' ;

define('CNXDBG', false);

function getLocalCabinXMLStatus()
{
	$url =  BASE . 'scripts/check_cabin_status.php';
	dbg(CNXDBG, "getting local cabin status XML file at $url");	   
	$xmlstring = file_get_contents($url);
	$xml = simplexml_load_string($xmlstring);
	dbg(CNXDBG, "got local cabin status XML: $xmlstring");	   
	return $xml;
}


function sendServerNbPhotos($statusXml)
{
	// get the local amount of unsynced photos

	$url = SSITE . 'scripts/cabine.php?device=' . $statusXml->device . '&nb_photos=' . $statusXml->nb_photos ;
	
	if (array_key_exists('standby', $_GET))
	{
		$standby = (int) getParam('standby', $_GET, 0) ;
		$url .= '&standby=' . $standby ;
	}

	// those values seems to never be sent by any caller. FIXME: DEAD CODE?
	if (array_key_exists('memory_bug', $_GET))
	{
		$url .= '&memory_bug=1' ;
	}
	
	if (array_key_exists('webcam_bug', $_GET))
	{
		$url .= '&webcam_bug=1' ;
	}
	dbg(CNXDBG, "sending nb_photos with url $url");	   
	file_get_contents($url) ;
}
function sendServerPrinterStatus($statusXml)
{
	$statePrinter = checkPrinterState() ;
	if ($statePrinter)
	{
		$url = SSITE . 'scripts/cabine.php?device=' . $statusXml->device;
		$url .= '&printer_state=' . $statusXml->printer_status ;
		$url .= '&printer_photos_remaining=' . $statusXml->printer_photos_remaining ;
		dbg(CNXDBG, "sending printer status with url $url");	   
		file_get_contents($url) ;
	}

}

function sendServerCabinSanity($statusXml)
{
	$url = SSITE . 'scripts/cabine.php?device=' . $statusXml->device;
	$url .= '&cabin_is_sane=' . $statusXml->cabin_is_sane;
	dbg(CNXDBG, "sending cabin_is_sane with url $url");
	file_get_contents($url);
}
function main()
{
	$statusXml = getLocalCabinXMLStatus();
	if (! is_server_reachable()){
		dbg(CNXDBG, "server not reachable");
		return;
	}
	sendServerNbPhotos($statusXml);
	sendServerPrinterStatus($statusXml);
	sendServerCabinSanity($statusXml);
		
}

main();
?>
