<?php
include_once 'config.php' ;

ini_set('max_execution_time', 500);

const QUEUEDBG = true;
/* // FOR PHP 8.1... ONE DAY...  
enum PythonErrCode: int{
    case    EPT_STATUS_OK=0;
    case	SERIAL_PORT_NOT_FOUND=1;
    case	EPT_NOT_FOUND=2;
    case    EPT_PAYMENT_WAITING=3;
    case 	EPT_OR_SERIAL_PORT_FAILURE=4;
    case 	EPT_NOT_REQUIRED=5;
    case 	EPT_PAYMENT_OK=6;
    case 	EPT_PAYMENT_PURSE_FAILURE=7;
    case 	EPT_PAYMENT_AUTHORISATION_FAILURE=8;
    case 	EPT_PAYMENT_TIMEOUT=9;
    case 	EPT_PAYMENT_DEVICE_CANCEL=10;
    case 	INTERNAL_EXCEPTION=11;
    case 	EPT_LIBRARY_ERROR=12;
    case 	EPT_UNHANDLED_ERROR=13;
    case    EPT_PAYMENT_TAKING_FOREVER=14; 
	case    UNHANDLED_PENDING_TRANSACTION=15;
	case    EPT_CANNOT_REACH_SERVER=16;
}
*/
const   PYTHON_ERR_CODE_EPT_STATUS_OK=0;
const	PYTHON_ERR_CODE_SERIAL_PORT_NOT_FOUND=1; //maintenance
const	PYTHON_ERR_CODE_EPT_NOT_FOUND=2; // maintenance
const   PYTHON_ERR_CODE_EPT_PAYMENT_WAITING=3; // UNUSED
const 	PYTHON_ERR_CODE_EPT_OR_SERIAL_PORT_FAILURE=4; // maintenance
const 	PYTHON_ERR_CODE_EPT_NOT_REQUIRED=5;
const 	PYTHON_ERR_CODE_EPT_PAYMENT_OK=6;
const 	PYTHON_ERR_CODE_EPT_PAYMENT_PURSE_FAILURE=7; 
const 	PYTHON_ERR_CODE_EPT_PAYMENT_AUTHORISATION_FAILURE=8; // UNUSED
const 	PYTHON_ERR_CODE_EPT_PAYMENT_TIMEOUT=9;
const 	PYTHON_ERR_CODE_EPT_PAYMENT_DEVICE_CANCEL=10;
const 	PYTHON_ERR_CODE_INTERNAL_EXCEPTION=11; // maintenance
const 	PYTHON_ERR_CODE_EPT_LIBRARY_ERROR=12; // maintenance
const 	PYTHON_ERR_CODE_EPT_UNHANDLED_ERROR=13; // maintenance 
const   PYTHON_ERR_CODE_EPT_PAYMENT_TAKING_FOREVER=14; // maintenance
const   PYTHON_ERR_CODE_UNHANDLED_PENDING_TRANSACTION=15;
const   PYTHON_ERR_CODE_EPT_CANNOT_REACH_SERVER=16;

const PAYMENT_TABLE = "photocabine_auto_jobs_payment";
const STATUS_TABLE = "photocabine_status";

// PHP 5.5.12 does not allow const arrays... PHP 7 does

/*const */ $ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_BAD_INPUT = [
    PYTHON_ERR_CODE_EPT_PAYMENT_PURSE_FAILURE,
	PYTHON_ERR_CODE_EPT_CANNOT_REACH_SERVER
    ];

    /*const */ $ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_TIMEOUT = [
    PYTHON_ERR_CODE_EPT_PAYMENT_TIMEOUT,
    ];
    
/*const */$ERRORS_CATEGORY_NEED_TRY_AGAIN = [
    PYTHON_ERR_CODE_EPT_PAYMENT_DEVICE_CANCEL,
    ];
/*const */$ERRORS_CATEGORY_NEED_GO_NEXT_SCREEN  =  [
      PYTHON_ERR_CODE_EPT_PAYMENT_OK
    ];
  
/*const */   $ERRORS_CATEGORY_NEED_MAINTENANCE = [
        PYTHON_ERR_CODE_SERIAL_PORT_NOT_FOUND,
        PYTHON_ERR_CODE_EPT_NOT_FOUND,
        PYTHON_ERR_CODE_EPT_OR_SERIAL_PORT_FAILURE,
        PYTHON_ERR_CODE_INTERNAL_EXCEPTION,
        PYTHON_ERR_CODE_EPT_LIBRARY_ERROR,
        PYTHON_ERR_CODE_EPT_UNHANDLED_ERROR,
        PYTHON_ERR_CODE_EPT_PAYMENT_TAKING_FOREVER
];
    

function leave($data, $error_code, $reason=null)
{
    if ($reason) {
        dbg(true, $reason);
    }
    $data["error_code"] = $error_code;
    $json_data = json_encode($data);
    dbg(true, "json_data is " . $json_data);    
    print(json_encode($data));
    exit();
}

function check_key_missing($dict, $keys)
{
    $ret = 0;
    dbg(true, "confronting dictionary " . json_encode($dict) . "vs keys ", json_encode($keys));
    foreach ($keys as $k)
    if (!array_key_exists($k, $dict)) {
        dbg(true, "in dictionary " . json_encode($dict) . " key $k is missing");
        $ret = 1;
        break;
    }
    return $ret;
}

$oConfigXml = simplexml_load_file(getXmlFile('config.xml')) ;
if (! isset($oConfigXml)) {
    dbg(true, "XML file not found, skipping this turn");
    exit;
}

$return_data = [];

if(! isset($_POST) ) {
    leave($return_data, ERR_CODE_MISSING_INPUT, "no POST data, quitting");
}
//var_dump($_POST);
dbg(CRASHDBG, "post data is " . json_encode($_POST) . " so json_data ---> " . json_encode($_POST["json_data"]));
if (! isset($_POST['json_data'])) {
    leave($return_data, ERR_CODE_BAD_INPUT, "no json_data in POST, quitting");
}
$json_string = $_POST["json_data"];
dbg(CRASHDBG, "json string is " . $json_string);

$json_data = json_decode($json_string, /* as_array= */ true); // warning, $json_data is a stdClass, second argument makes it an arra

dbg(CRASHDBG, "json_data is " . json_encode($json_data));
/*
    //warning: json_decode does not provide a pure array but an stdclass, array_interesect_data either further casting, or json_decode needs second parameter to true.
    but fake_json_data works: 
    $fake_json_data = array("id_photo" => 9999);
    dbg(CRASHDBG, "fake_json_data is " . json_encode($fake_json_data));
*/

$mandatory_table_fields = ["date", "id_photocabine_status", "ttl_seconds_record", "fee_cents_record", "config_record"];
if (check_key_missing($json_data, $mandatory_table_fields)) {
    leave($return_data, ERR_CODE_MISSING_INPUT, "some input keys are missing");
}

$all_table_fields = $mandatory_table_fields;

$insert_data = array_intersect_key($json_data, array_flip($all_table_fields));

dbg(CRASHDBG, "insert_data is " . json_encode($insert_data));

/* mark obsolete transactions as obsolete */

$d = array();
$d['error_code'] = PYTHON_ERR_CODE_UNHANDLED_PENDING_TRANSACTION;
$d['error_code_hr'] = "ERR_CODE_UNHANDLED_PENDING_TRANSACTION(queue_job_payment)";
my_update($db, PAYMENT_TABLE, $d, 'error_code is NULL and date < \'' . $insert_data['date'] . '\'');

$insert_id = my_insert($db, PAYMENT_TABLE, $insert_data);
dbg(QUEUEDBG, "-> got insert_id: ". $insert_id);


$return_data["date"] = $insert_data["date"];
$return_data["id"] = $insert_id;

$JOB_DONE_POLL_DELAY = 0.25;
$sql = "SELECT * FROM " . PAYMENT_TABLE . " WHERE id = ". $insert_id . " AND error_code IN ('";

foreach ($ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_BAD_INPUT as $err) {
    $sql .= $err . "', '";
}
foreach ($ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_TIMEOUT as $err) {
    $sql .= $err . "', '";
}
foreach ($ERRORS_CATEGORY_NEED_GO_NEXT_SCREEN as $err) {
    $sql .= $err . "', '";
}
foreach ($ERRORS_CATEGORY_NEED_MAINTENANCE as $err) {
    $sql .= $err . "', '";
}
foreach ($ERRORS_CATEGORY_NEED_TRY_AGAIN as $err) {
    $sql .= $err . "', '";
}
$sql.= "-999')"; // fake final value to close the sql request //FIXME
/*
$sql .= PYTHON_ERR_CODE_OK . "', '";
$sql .= PYTHON_ERR_CODE_RBG_API_FATAL . "', '";
$sql .= PYTHON_ERR_CODE_INTERNAL_EXCEPTION_FATAL . "', '";
$sql .= PYTHON_ERR_CODE_RBG_TIMEOUT_FATAL . "', '";
$sql .= PYTHON_ERR_CODE_INTERNET_DOWN_FATAL . "')";
*/
dbg(QUEUEDBG, "sql is: '$sql'");
$then = time();
$processed_in_time = false;
const PAYMENT_HARD_TIMEOUT_DEFAULT=360;
$payment_hard_timeout = isset($oConfigXml->general->payment->waitEPTTimeMax) ? $oConfigXml->general->payment->waitEPTTimeMax : PAYMENT_HARD_TIMEOUT_DEFAULT;
while ((time() - $then) < $payment_hard_timeout /*$insert_data["ttl_seconds_record"] */ ) 
{
    $line = my_select($db, $sql);
    if ($line) {
        $return_data["error_code_low_level"] = $line->error_code;
        dbg(QUEUEDBG, "DONE! waited " . strval(time() - $then)  . " seconds, error_code: ". $line->error_code);
        if (in_array($line->error_code, $ERRORS_CATEGORY_NEED_GO_NEXT_SCREEN)) { 
            $d = ['payment_credit' =>  1];
            dbg(QUEUEDBG, "SETTING PAYMENT_CREDIT to ONE");
            my_update($db, STATUS_TABLE, $d, 'id = ' . $json_data['id_photocabine_status']);

            leave($return_data, ERR_CODE_OK, "job ended normally in time. PAYMENT CREDIT HAS BEEN SET");

        }
        else if (in_array($line->error_code, $ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_BAD_INPUT)) { 
            leave($return_data, ERR_CODE_BAD_INPUT, "job ended abnormally with BAD_INPUT error category:", $line->error_code);
        }
        else if (in_array($line->error_code, $ERRORS_CATEGORY_NEED_TRY_AGAIN)) { 
            leave($return_data, ERR_CODE_TRY_AGAIN, "job ended abnormally with TRY_AGAIN error category:", $line->error_code);
            $then = time(); // reset the hard stop loop because we start over
        }
        else if (in_array($line->error_code, $ERRORS_CATEGORY_NEED_RETURN_TO_APP_START_DUE_TO_TIMEOUT)) { 
            leave($return_data, ERR_CODE_TIMEOUT, "job ended abnormally with TIMEOUT error category:", $line->error_code);
        }
        else if (in_array($line->error_code, $ERRORS_CATEGORY_NEED_MAINTENANCE)) { 
            leave($return_data, ERR_CODE_FATAL, "job ended abnormally with FATAL error category:", $line->error_code);
        }
        else {
            leave($return_data, ERR_CODE_UNKNOWN, "job ended abnormally with UNKNOWN error category:", $line->error_code);
        }
        $processed_in_time = true;
        break;
    } else {
        dbg(false && QUEUEDBG, "waiting $JOB_DONE_POLL_DELAY seconds");
        usleep($JOB_DONE_POLL_DELAY * ONE_SECOND_IN_USEC);
    }
}
if (! $processed_in_time) {
    $e = PYTHON_ERR_CODE_EPT_PAYMENT_TAKING_FOREVER;
    $n = "EPT_PAYMENT_TAKING_FOREVER";
    $d = ["error_code" => $e, "error_code_hr" => $n];
    my_update($db, PAYMENT_TABLE, $d, 'id = ' . $insert_id);
    leave($return_data, ERR_CODE_FATAL, "FATAL:payment queue job fully timed out, something bad might be happening!");
}
leave($return_data, ERR_CODE_UNKNOWN, "UNKNOWN ERROR, should not be there");
?>